import { jsx as g, jsxs as ce } from "react/jsx-runtime";
import se, { useRef as d, useEffect as C, useCallback as le, useMemo as j, useState as _, useId as ie, useReducer as ue, useLayoutEffect as N } from "react";
import i from "clsx";
/*!
  @versini/ui-textarea v2.0.0
  © 2024 gizmette.com
*/
try {
  window.__VERSINI_UI_TEXTAREA__ || (window.__VERSINI_UI_TEXTAREA__ = {
    version: "2.0.0",
    buildTime: "12/29/2024 04:16 PM EST",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
const G = "av-text-area", de = "av-text-area-wrapper", H = "av-text-area-helper-text", fe = "av-text-area__control--right";
function pe() {
  const e = d(!1);
  return C(() => (e.current = !0, () => {
    e.current = !1;
  }), []), le(() => e.current, []);
}
function me(e) {
  return j(() => e.every((r) => r == null) ? () => {
  } : (r) => {
    e.forEach((t) => {
      typeof t == "function" ? t(r) : t != null && (t.current = r);
    });
  }, e);
}
const ye = {
  x: 0,
  y: 0,
  width: 0,
  height: 0,
  top: 0,
  left: 0,
  bottom: 0,
  right: 0
};
function he(e) {
  const r = pe(), t = d(0), n = d(null), [a, c] = _(ye), o = j(() => typeof ResizeObserver > "u" ? null : new ResizeObserver((s) => {
    const l = s[0];
    l && (cancelAnimationFrame(t.current), t.current = requestAnimationFrame(() => {
      n.current && r() && c(l.contentRect);
    }));
  }), [r]);
  return C(() => (n.current && (o == null || o.observe(n.current, e)), () => {
    o == null || o.disconnect(), t.current && cancelAnimationFrame(t.current);
  }), [o, e]), [n, a];
}
function xe({
  value: e,
  defaultValue: r,
  finalValue: t,
  onChange: n = () => {
  },
  initialControlledDelay: a = 0
}) {
  const [c, o] = _(!1), [s, l] = _(
    r !== void 0 ? r : t
  ), f = (p) => {
    l(p), n == null || n(p);
  };
  return C(() => {
    (async () => e !== void 0 && !c && a > 0 && (await new Promise(
      (p) => setTimeout(p, a)
    ), o(!0)))();
  }, [e, a, c]), e !== void 0 ? !c && a > 0 ? ["", n, !0] : [e, n, !0] : [s, f, !1];
}
function Ae(e) {
  const r = ie();
  if (!e)
    return r;
  if (typeof e == "number" || typeof e == "string")
    return `${e}${r}`;
  if (typeof e == "object") {
    const { id: t, prefix: n = "" } = e;
    return typeof t == "number" || typeof t == "string" ? `${n}${t}` : `${n}${r}`;
  }
}
const z = "SET_ANNOUNCEMENT", W = "CLEAR_ANNOUNCEMENT", ge = {
  alert: null,
  alertdialog: null,
  log: "polite",
  marquee: null,
  progressbar: null,
  status: "polite",
  timer: "assertive"
}, Te = (e, r) => {
  switch (r == null ? void 0 : r.type) {
    case z:
      return {
        ...e,
        announcement: r.payload
      };
    case W:
      return {
        ...e,
        announcement: null
      };
    default:
      return e;
  }
}, be = ({
  onAnnouncementClear: e,
  dispatch: r
}) => {
  r({
    type: W
  }), typeof e == "function" && e();
}, X = ({
  children: e,
  clearAnnouncementDelay: r,
  clearAnnouncementTimeoutRef: t,
  onAnnouncementClear: n,
  dispatch: a
}) => {
  clearTimeout(t.current), e !== null && a({
    type: z,
    payload: e
  }), r && (t.current = setTimeout(
    () => be({
      onAnnouncementClear: n,
      dispatch: a
    }),
    r
  ));
}, ke = ({
  children: e,
  announcementTimeoutRef: r,
  announcementDelay: t,
  clearAnnouncementDelay: n,
  clearAnnouncementTimeoutRef: a,
  onAnnouncementClear: c,
  dispatch: o
}) => {
  clearTimeout(r.current), t ? r.current = setTimeout(X, t, {
    children: e,
    clearAnnouncementDelay: n,
    clearAnnouncementTimeoutRef: a,
    onAnnouncementClear: c,
    dispatch: o
  }) : X({
    children: e,
    clearAnnouncementDelay: n,
    clearAnnouncementTimeoutRef: a,
    onAnnouncementClear: c,
    dispatch: o
  });
};
function Ee({
  children: e,
  className: r,
  politeness: t,
  role: n = null,
  announcementDelay: a,
  clearAnnouncementDelay: c,
  onAnnouncementClear: o,
  visible: s,
  ...l
}) {
  const f = d(null), p = d(null), [T, k] = ue(Te, {
    announcement: null
  });
  let x = t;
  typeof x > "u" && (x = n ? ge[n] : "assertive"), C(() => {
    ke({
      announcementTimeoutRef: f,
      announcementDelay: a,
      children: e,
      clearAnnouncementDelay: c,
      clearAnnouncementTimeoutRef: p,
      onAnnouncementClear: o,
      dispatch: k
    });
  }, [
    e,
    a,
    c,
    o
  ]);
  const m = i(r, {
    "sr-only": !s
  });
  return /* @__PURE__ */ g(
    "div",
    {
      "aria-live": x,
      ...n && { role: n },
      className: m,
      ...l,
      children: T.announcement
    }
  );
}
/*!
  @versini/ui-liveregion v1.2.2
  © 2024 gizmette.com
*/
try {
  window.__VERSINI_UI_LIVEREGION__ || (window.__VERSINI_UI_LIVEREGION__ = {
    version: "1.2.2",
    buildTime: "12/29/2024 04:16 PM EST",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
const _e = () => "rounded-md text-base h-20 min-h-[80px] resize-none overflow-hidden px-4 py-7", Re = ({
  mode: e
}) => i({
  "bg-surface-darker text-copy-lighter caret-copy-light": e === "dark",
  "bg-surface-lighter text-copy-dark caret-copy-dark": e === "light",
  "bg-surface-lighter text-copy-dark caret-copy-dark dark:bg-surface-darker dark:text-copy-lighter dark:caret-copy-light": e === "system",
  "bg-surface-darker text-copy-lighter caret-copy-light dark:bg-surface-lighter dark:text-copy-dark dark:caret-copy-dark": e === "alt-system"
}), ve = ({
  focusMode: e
}) => i("focus:outline focus:outline-2 focus:outline-offset-2", {
  "focus:outline-focus-dark": e === "dark",
  "focus:outline-focus-light": e === "light",
  "focus:outline-focus-light dark:focus:outline-focus-dark": e === "alt-system",
  "focus:outline-focus-dark dark:focus:outline-focus-light": e === "system"
}), Ne = ({
  noBorder: e,
  error: r
}) => i("border-2", {
  "border-border-dark": !e && !r,
  "focus:border-border-dark": !e && r,
  "border-border-error-dark": !e && r,
  "border-transparent": e
}), Ce = ({
  disabled: e,
  raw: r,
  error: t,
  mode: n
}) => {
  if (r)
    return "";
  if (e)
    return i("absolute px-2 cursor-not-allowed opacity-50 font-medium");
  if (!t)
    return i("absolute px-2 cursor-text font-medium", {
      "text-copy-medium": n === "dark",
      "text-copy-dark": n === "light",
      "text-copy-dark dark:text-copy-medium": n === "system",
      "text-copy-medium dark:text-copy-dark": n === "alt-system"
    });
  if (t)
    return i("absolute px-2 cursor-text font-medium", {
      "text-copy-medium": n === "dark",
      "text-copy-error-dark": n === "light",
      "text-copy-error-dark dark:text-copy-error-light": n === "system",
      "text-copy-medium dark:text-copy-error-dark": n === "alt-system"
    });
}, Ie = ({
  error: e,
  raw: r,
  mode: t,
  disabled: n
}) => {
  if (r)
    return "";
  if (n)
    return i(
      H,
      "absolute px-2 cursor-not-allowed opacity-50 font-medium"
    );
  if (!e)
    return i(H, "absolute px-2 font-medium", {
      "text-copy-medium": t === "dark",
      "text-copy-dark": t === "light",
      "text-copy-dark dark:text-copy-medium": t === "system",
      "text-copy-medium dark:text-copy-dark": t === "alt-system"
    });
  if (e)
    return i(H, "absolute px-2 font-medium", {
      "text-copy-error-light": t === "dark",
      "text-copy-error-dark": t === "light",
      "text-copy-error-dark dark:text-copy-error-light": t === "system",
      "dark:text-copy-error-dark text-copy-error-light": t === "alt-system"
    });
}, Se = ({
  className: e,
  textAreaClassName: r,
  raw: t,
  focusMode: n,
  disabled: a,
  noBorder: c,
  error: o,
  mode: s
}) => {
  const l = t ? e : i(
    "relative flex w-full flex-col justify-center",
    de,
    e
  ), f = t ? i(r) : i(
    G,
    r,
    _e(),
    Re({ mode: s }),
    ve({ focusMode: n }),
    Ne({
      noBorder: c,
      error: o
    }),
    {
      "disabled:cursor-not-allowed disabled:opacity-50": a
    }
  ), p = t ? void 0 : "sr-only", T = Ce({
    disabled: a,
    raw: t,
    error: o,
    mode: s
  }), k = Ie({
    error: o,
    raw: t,
    mode: s,
    disabled: a
  }), x = t ? void 0 : i(fe, "absolute");
  return {
    wrapper: l,
    textArea: f,
    accessibleLabel: p,
    visibleLabel: T,
    helperText: k,
    rightElement: x
  };
}, Oe = ({
  scrollHeight: e,
  currentHeight: r,
  currentLabelOffset: t = 0,
  currentHelperTextOffset: n = 0
}) => {
  let o, s;
  if (e > 0 && e !== r) {
    const l = e - r, f = Math.abs(l / 24);
    o = t + -1 * Math.sign(l) * (12 * f), s = n + Math.sign(l) * (12 * f);
  }
  return {
    labelOffset: o,
    helperTextOffset: s,
    scrollHeight: e
  };
}, Le = se.forwardRef(
  ({
    id: e,
    name: r,
    label: t,
    error: n = !1,
    raw: a = !1,
    className: c,
    textAreaClassName: o,
    mode: s = "system",
    focusMode: l = "system",
    value: f,
    defaultValue: p,
    disabled: T = !1,
    noBorder: k = !1,
    labelId: x,
    helperText: m = "",
    helperTextOnFocus: I = !1,
    rightElement: S,
    onChange: D,
    onFocus: M,
    onBlur: F,
    ...q
  }, B) => {
    const y = d(null), J = me([B, y]), [K, R] = he(), O = d(80), P = d(-25), A = d(null), U = d(30), v = d(null), E = Ae({ id: e, prefix: `${G}-` }), [Q, Y] = _(0), [Z, V] = _(
      !!(!I && m)
    ), ee = `${r} error, ${m}`, b = Se({
      className: c,
      textAreaClassName: o,
      error: n,
      raw: a,
      focusMode: l,
      disabled: T,
      noBorder: k,
      mode: s
    }), [h, te] = xe({
      value: f,
      initialControlledDelay: 20,
      defaultValue: p,
      onChange: (u) => {
        D && D({
          target: {
            value: u
          }
        });
      }
    }), re = (u) => {
      te(u.target.value);
    }, ne = (u) => {
      I && m && V(!0), M && M(u);
    }, ae = (u) => {
      I && m && !h && V(!1), F && F(u);
    };
    return N(() => {
      R && R.width && Y(R.width + 18 + 10);
    }, [R]), N(() => {
      a || y && y.current && h !== void 0 && (y.current.style.height = "inherit", y.current.style.height = y.current.scrollHeight + "px");
    }, [h, a]), N(() => {
      a || setTimeout(() => {
        var u;
        (u = A == null ? void 0 : A.current) == null || u.style.setProperty(
          "--av-text-area-wrapper-transition",
          h ? "none" : "all 0.2s ease-out"
        );
      }, 0);
    }, [h, a]), N(() => {
      var u, L;
      if (!a && y && y.current && h !== void 0) {
        const { labelOffset: w, helperTextOffset: $, scrollHeight: oe } = Oe({
          scrollHeight: y.current.scrollHeight,
          currentHeight: O.current,
          currentLabelOffset: P.current,
          currentHelperTextOffset: U.current
        });
        w && (P.current = w, (u = A == null ? void 0 : A.current) == null || u.style.setProperty(
          "--av-text-area-label",
          `${w}px`
        )), $ && (U.current = $, (L = v == null ? void 0 : v.current) == null || L.style.setProperty(
          "--av-text-area-helper-text",
          `${$}px`
        )), O.current = oe || O.current;
      }
    }, [h, a]), /* @__PURE__ */ ce("div", { className: b.wrapper, children: [
      /* @__PURE__ */ g(
        "label",
        {
          htmlFor: E,
          id: x,
          className: b.accessibleLabel,
          children: t
        }
      ),
      /* @__PURE__ */ g(
        "textarea",
        {
          ref: J,
          id: E,
          name: r,
          disabled: T,
          placeholder: a ? void 0 : " ",
          className: b.textArea,
          rows: 1,
          ...m && { "aria-describedby": `${E}-helper` },
          ...n && { "aria-invalid": "true" },
          ...S && !a && { style: { paddingRight: Q } },
          value: h,
          onChange: re,
          onFocus: ne,
          onBlur: ae,
          ...q
        }
      ),
      !a && /* @__PURE__ */ g(
        "label",
        {
          ref: A,
          "aria-hidden": !0,
          htmlFor: E,
          className: b.visibleLabel,
          children: t
        }
      ),
      Z && /* @__PURE__ */ g(
        "div",
        {
          ref: v,
          id: `${E}-helper`,
          className: b.helperText,
          children: m
        }
      ),
      S && /* @__PURE__ */ g(
        "div",
        {
          ref: K,
          className: b.rightElement,
          children: S
        }
      ),
      n && m && /* @__PURE__ */ g(Ee, { politeness: "polite", clearAnnouncementDelay: 500, children: ee })
    ] });
  }
);
Le.displayName = "TextArea";
export {
  G as TEXT_AREA_CLASSNAME,
  fe as TEXT_AREA_CONTROL_RIGHT_CLASSNAME,
  H as TEXT_AREA_HELPER_TEXT_CLASSNAME,
  de as TEXT_AREA_WRAPPER_CLASSNAME,
  Le as TextArea
};
